import React from 'react'
import { Provider }    from 'react-redux'
import { createStore } from 'redux'
import { createStackNavigator, createAppContainer } from 'react-navigation'
import * as screens    from './App/Screens'
import projectReducer  from './App/Reducers/ProjectReducer'

const store = createStore(projectReducer);

const StackNav = createStackNavigator(
  {
    Home:       screens.Home,
    Loading:    screens.Loading,
    NameProj:   screens.NameProj,
    UploadSong: screens.UploadSong,
    LoadCreate: screens.LoadCreate,
    Overview:   screens.Overview,
    Create:     screens.Create,
    ARView:     screens.ARView,
    Transition:    screens.Transition,
  },
  {
    headerMode: 'screen',
  },
);

const RootNav = createAppContainer(StackNav);

export default class App extends React.Component {
  render() {
    return (
      <Provider store={store}>
        <RootNav/>
      </Provider>
    );
  }
}
