import React from 'react'
import { TouchableOpacity, View, StyleSheet, Text } from 'react-native'
import { FormationCard } from '.'
import { Images, Metrics, Colors }                  from '../Themes'

/* Hard coded danceCards to serve as previews to projects */
export default class DanceCard extends React.Component {
  /* A 6-Dancer formation */
  sixDancers = () => {
    return(
      <View style={{flex: 1, justifyContent:'center'}}>
        <View style={{ ...styles.dot, margin:7, alignSelf: 'center'}}/>
        <View style={{flexDirection:'row', justifyContent:'center'}}>
          <View style={{ ...styles.dot, margin:7}}/>
          <View style={{ ...styles.dot, margin:7}}/>
        </View>
        <View style={{flexDirection:'row', justifyContent:'center'}}>
          <View style={{ ...styles.dot, margin:7}}/>
          <View style={{ ...styles.dot, margin:7}}/>
          <View style={{ ...styles.dot, margin:7}}/>
        </View>
      </View>
    );
  }

  /* An 8-Dancer formation */
  eightDancers = () => {
    return(
      <View style={{flex: 1, flexDirection: 'row', justifyContent:'center'}}>
        <View style={{justifyContent:'center'}}>
          <View style={{ ...styles.dot, marginHorizontal:10, marginVertical:4}}/>
          <View style={{ ...styles.dot, marginHorizontal:10, marginVertical:4}}/>
          <View style={{ ...styles.dot, marginHorizontal:10, marginVertical:4}}/>
          <View style={{ ...styles.dot, marginHorizontal:10, marginVertical:4}}/>
        </View>
        <View style={{justifyContent:'center'}}>
        <View style={{ ...styles.dot, marginHorizontal:10, marginVertical:4}}/>
        <View style={{ ...styles.dot, marginHorizontal:10, marginVertical:4}}/>
        <View style={{ ...styles.dot, marginHorizontal:10, marginVertical:4}}/>
        <View style={{ ...styles.dot, marginHorizontal:10, marginVertical:4}}/>
        </View>
      </View>
    );
  }

  /* A 5-Dancer formation */
  fiveDancers = () => {
    return(
      <View style={{flex: 1, justifyContent:'center'}}>
        <View style={{flexDirection:'row', justifyContent:'center'}}>
          <View style={{ ...styles.dot, margin:7}}/>
          <View style={{ ...styles.dot, margin:7}}/>
          <View style={{ ...styles.dot, margin:7}}/>
        </View>
        <View style={{flexDirection:'row', justifyContent:'center'}}>
          <View style={{ ...styles.dot, margin:7}}/>
          <View style={{ ...styles.dot, margin:7}}/>
        </View>
      </View>
    );
  };

  render() {
    return (
      <View style={styles.container}>
        <TouchableOpacity style={styles.card} onPress={() => this.props.onPress()}>
        {(this.props.numDancers === 5) && this.fiveDancers()}
        {(this.props.numDancers === 8) && this.eightDancers()}
        {(this.props.numDancers === 6) && this.sixDancers()}
        </TouchableOpacity>
        <View style={styles.textBox}>
          <Text style={styles.text}>{this.props.name}</Text>
        </View>
      </View>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    alignItems: 'center',
  },
  card: {
    backgroundColor: Colors.accent,
    flex: 3,
    aspectRatio: 1,
    borderWidth: 1,
    borderColor: Colors.lightGradient,
    borderRadius: 4,
  },
  textBox: {
    flex: 1,
    justifyContent: 'center',
  },
  text: {
    color: Colors.snow,
    fontSize: 13,
  },
  firstExample: {
    flexDirection: 'row',
  },
  dot: {
    aspectRatio: 1,
    height: 14,
    backgroundColor: Colors.lightGradient,
    borderRadius: 14/2,
  },
});
