import React from 'react'
import { Animated, PanResponder, StyleSheet, View } from 'react-native'

let CIRCLE_RADIUS = 25;

export default class Dancer extends React.Component {
  state = {
    showDancer: false,
    //pan:
    pan: new Animated.ValueXY(),
    opacity: new Animated.Value(0),
    index: 0,
    name: ''
  };
  constructor(props) {
    super(props);
    this._val = {x:this.props.x, y:this.props.y}
    this.state.pan.setOffset({
          x: this.props.x,
          y: this.props.y,
        })
    this.state.pan.addListener((value) => this._val = value);


    this.panResponder = PanResponder.create({
      onStartShouldSetPanResponder: (e, gesture) => true,
      onPanResponderGrant: (e,gesture) => {
        this.setState(prevState => ({ index: prevState.index + 1}))
        Animated.timing(
          this.state.opacity,
          {
            toValue: 1
          }
        ).start(() => this.setState({showDancer: true}))
        this.state.pan.setOffset({
          x: this._val.x,
          y: this._val.y,
        })
        this.state.pan.setValue({x:0, y:0})
        if (this.state.index > 0) {
          this.props.changeStage(true)
        }
      },
      onPanResponderMove: Animated.event([
        null, { dx: this.state.pan.x, dy: this.state.pan.y }
      ]),
      onPanResponderRelease: (e, gesture) => {
        //this.props.update(this._val.x, this._val.y)
        if (this.isTrashArea(gesture)) {
          Animated.timing(
            this.state.opacity,
            {
              toValue: 0
            }
          ).start(() => this.setState({showDancer: false}))
        }
        this.props.changeStage(false)
      }
    })
  }

  isTrashArea(gesture) {
    //remember to reset the trash can zone area because it was messed up
    if ((gesture.moveX <= 95) && (gesture.moveY >= 200)) {
      return true;
    }
    return false;
  }

  render() {
    return (
      <View style={{ width: "20%", alignItems: "center" }}>
        {this.renderDancer()}
      </View>
    );
  }

  renderDancer() {

    const panStyle = {
      transform: this.state.pan.getTranslateTransform()
    }

    return (
      <View style={{ position: "absolute" }}>
        <Animated.View
          {...this.panResponder.panHandlers}
          style={[panStyle, styles.circle, {opacity:this.state.opacity}]}
        />
      </View>
    );
  }
}

const styles = StyleSheet.create({
  circle: {
    backgroundColor: "purple",
    width: CIRCLE_RADIUS * 2,
    borderRadius: CIRCLE_RADIUS * 2,
    borderWidth: 3,
    borderColor: "white",
    height: CIRCLE_RADIUS * 2,
    borderRadius: CIRCLE_RADIUS
  },
});
