import React from 'react'
import { Animated, PanResponder, StyleSheet, View, TouchableOpacity, Text } from 'react-native'
import { Colors, Images, Metrics } from '../Themes'

let CIRCLE_RADIUS = 25;

export default class DancerTransition extends React.Component {
  state = {
    pressed: false,
    pan: new Animated.ValueXY(),
    name: '', 
  }; 
  constructor(props) {
    super(props);
  }

  render() {
    return (
      <View style={{ width: "20%", alignItems: "center" }}>
        {this.renderDancer()}
      </View>
    );
  }

  press = () => {
    this.props.setDancerPress(this.props.index); 
    let current = this.state.pressed; 
    this.setState({pressed: !current}); 
  }

  renderDancer() {
    return (
      <View style={{ position: "absolute" }}>
        <TouchableOpacity
          style={[styles.circle, {borderColor: (this.state.pressed && !this.props.clear) ? "black" : "white", position: 'absolute', start: this.props.x, top: this.props.y}]}
          onPress = {this.press.bind()}
          activeOpacity = {.75}
          >
          <Text style = {{fontSize: 23, fontWeight: 'bold', color: (this.state.pressed && !this.props.clear) ? "black" : "white"}}> {this.props.name} </Text> 
        </TouchableOpacity> 
       {/* />*/}
      </View>
    );
  }
}

const styles = StyleSheet.create({
  circle: {
    justifyContent: 'center', 
    alignItems: 'center', 
    backgroundColor: Colors.lightGradient,
    width: CIRCLE_RADIUS * 2,
    borderRadius: CIRCLE_RADIUS * 2,
    borderWidth: 3,
    height: CIRCLE_RADIUS * 2,
    borderRadius: CIRCLE_RADIUS
  },
});
