import React from 'react'
import { TouchableOpacity, View, StyleSheet, Text } from 'react-native'
import { LinearGradient }  from 'expo'
import { Metrics, Colors } from '../Themes'

/* Large curved button */
export default class LargeButton extends React.Component {
  render() {
    return (
      <View style={this.props.style}>
        <TouchableOpacity onPress={this.props.onPress}>
          <LinearGradient
            colors={[Colors.darkGradient, Colors.midGradient, Colors.lightGradient]}
            style={styles.button}
            start={[0, 1]}
            end={[1, 0]}
            locations={[0, 0.5, 1.3]}
          >
            <Text style={styles.text}>{this.props.text}</Text>
          </LinearGradient>
        </TouchableOpacity>
      </View>
    );
  }
}

const styles = StyleSheet.create({
  button: {
    justifyContent: 'center',
    alignItems: 'center',
    width: 206,
    height: 67,
    borderRadius: 53,
    paddingHorizontal: Metrics.tripleBaseMargin,
    backgroundColor: Colors.darkGradient,
  },
  text: {
    fontSize: Metrics.text.button,
    color: Colors.snow,
  }
});
