import React from 'react'
import { StyleSheet, Text, TouchableOpacity, View } from 'react-native'
import { Colors, Metrics }                          from '../Themes'

/* Shows a project's music title */
export default class SongCard extends React.Component {
  render() {
    return (
      <TouchableOpacity onPress={() =>this.props.onPress()}>
        <View style={styles.container}>
          <Text style={styles.text}>{this.props.name}</Text>
        </View>
      </TouchableOpacity>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    justifyContent: 'center',
    height: Metrics.buttons.songCard,
    backgroundColor: Colors.accent,
  },
  text: {
    fontSize: Metrics.text.normal,
    color: Colors.snow,
    marginLeft: Metrics.doubleSection,
  }
});
