import { combineReducers }           from 'redux'
import { SAVE_PROJECT, CHANGE_FORMATION } from './types'

const INITIAL_STATE = {
  recent: [
    {
      id: -1,
      name: "PS GFY",
      numDancers: 5,
      formations: [ {positions: []}, {positions: []}, {positions: []} ],
    },
    {
      id: -2,
      name: "Barbados",
      numDancers: 8,
      formations: [ {positions: []}, {positions: []}, {positions: []} ],
    },
    {
      id: -3,
      name: "Breaking Ground 2018",
      numDancers: 6,
      formations: [ {positions: []}, {positions: []}, {positions: []} ],
    },
  ],
  all: [
    {
      name: "Girls Like U",
    },
    {
      name: "Where Are Ü Now",
    },
    {
      name: "Lost in Japan",
    },
    {
      name: "Move Me",
    },
    {
      name: "Feel It Still",
    },
    {
      name: "Work",
    },
    {
      name: "Congratulations",
    },
  ],
  taskOneDone: false,
  taskTwoDone: false,
}
;

const projectReducer = (state = INITIAL_STATE, action) => {
  const { recent, all, taskOneDone } = state;

  switch (action.type) {
    case SAVE_PROJECT:
      return { recent, all, taskOneDone: true }

    case CHANGE_FORMATION:
      return { recent, all, taskTwoDone: true }

    default:
      return state;
  }
};

export default combineReducers({
  projects: projectReducer,
});
