import React from 'react'
import { Image, StyleSheet, Text, View } from 'react-native'
import { Colors, Images, Metrics }       from '../Themes'

/**
 * Loading new project screen
 * ------------------------------------
 * - Shown when beginning a new project
 */
export default class LoadCreate extends React.Component {
  /* Navigation options */
  static navigationOptions = {
    header: null
  }

  render() {
    msg = 'Just a second! We are\npreparing your canvas...';
    return (
      <View style={styles.container}>
        <Text style={styles.text}>{msg}</Text>
        <Image
          style={styles.image}
          source={Images.loading}
          resizeMode='contain'
        />
      </View>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    alignItems: 'center',
    justifyContent: 'center',
    backgroundColor: Colors.background,
  },
  text: {
    textAlign: 'center',
    position: 'absolute',
    top: Metrics.screenHeight*0.4,
    fontSize: Metrics.text.header,
    color: Colors.snow,
  },
  image: {
    width: Metrics.images.xlarge,
    position: 'absolute',
    top: Metrics.screenHeight*0.25,
  },
});
