import React from 'react'
import { Image, StyleSheet, Text, View } from 'react-native'
import { Colors, Images, Metrics }       from '../Themes'

/**
 * Main loading screen
 * ------------------------------------
 * - Shown when loading the Home Screen
 */
export default class Loading extends React.Component {
  /* Navigation options */
  static navigationOptions = {
    header: null
  }

  render() {
    return (
      <View style={styles.container}>
        <Image
          style={{width: Metrics.images.logo}}
          source={Images.fullLogo}
          resizeMode='contain'
        />
      </View>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    alignItems: 'center',
    justifyContent: 'center',
    backgroundColor: Colors.background,
  },
});
