import React from 'react'
import {
  Alert, Image, ImageBackground, Platform, SafeAreaView, StatusBar, StyleSheet,
  Text, TouchableOpacity, View
} from 'react-native'
import { DancerTransition, Stage, SecondFormation }           from '../Components'
import { Colors, Images, Metrics } from '../Themes'
import { Constants, Svg } from 'expo';

let CIRCLE_RADIUS = 25;

/* - this is formation 2 to 3
const dancerList = [
	{
		name: "A",
		xVal: 500,
		yVal: 100,
	},
	{
		name: "J",
		xVal: 160,
		yVal: 100,
	},
	{
		name: "M",
		xVal: 330,
		yVal: 100,
	},
	{
		name: "S",
		xVal: 255,
		yVal: 200,
	},
	{
		name: "R",
		xVal: 405,
		yVal: 200,
	}
]

const formationTwo = [
	{
		name: "",
		xVal: 500,
		yVal: 200,
	},
	{
		name: "",
		xVal: 160,
		yVal: 200,
	},
	{
		name: "",
		xVal: 330,
		yVal: 200,
	},
	{
		name: "",
		xVal: 255,
		yVal: 100,
	},
	{
		name: "",
		xVal: 405,
		yVal: 100,
	}
]

const transitionPoint = [
	{
		name: "",
		x1: 500,
		y1: 100,
		x2: 500,
		y2: 200,
	},
	{
		name: "",
		x1: 160,
		y1: 100,
		x2: 160,
		y2: 200,
	},
	{
		name: "",
		x1: 330,
		y1: 100,
		x2: 330,
		y2: 200,
	},
	{
		name: "",
		x1: 255,
		y1: 200,
		x2: 255,
		y2: 100,
	},
	{
		name: "",
		x1: 405,
		y1: 200,
		x2: 405,
		y2: 100,
	}
]

const pressedTracker = [
	{
		index: 0,
		first: false,
		second: false
	},
	{
		index: 1,
		first: false,
		second: false
	},
	{
		index: 2,
		first: false,
		second: false
	},
	{
		index: 3,
		first: false,
		second: false
	},
	{
		index: 4,
		first: false,
		second: false
	},
]*/

const dancerList = [
	{
		name: "A",
		xVal: 580,
		yVal: 150,
	},
	{
		name: "J",
		xVal: 80,
		yVal: 150,
	},
	{
		name: "M",
		xVal: 330,
		yVal: 150,
	},
	{
		name: "S",
		xVal: 205,
		yVal: 150,
	},
	{
		name: "R",
		xVal: 455,
		yVal: 150,
	}
]

const formationTwo = [
	{
		name: "",
		xVal: 580,
		yVal: 250,
	},
	{
		name: "",
		xVal: 80,
		yVal: 250,
	},
	{
		name: "",
		xVal: 330,
		yVal: 250,
	},
	{
		name: "",
		xVal: 205,
		yVal: 50,
	},
	{
		name: "",
		xVal: 455,
		yVal: 5,
	}
]

const transitionPoint = [
	{
		name: "",
		x1: 580,
		y1: 150,
		x2: 580,
		y2: 250,
	},
	{
		name: "",
		x1: 80,
		y1: 150,
		x2: 80,
		y2: 250,
	},
	{
		name: "",
		x1: 330,
		y1: 150,
		x2: 330,
		y2: 250,
	},
	{
		name: "",
		x1: 205,
		y1: 150,
		x2: 205,
		y2: 50,
	},
	{
		name: "",
		x1: 455,
		y1: 150,
		x2: 455,
		y2: 50,
	}
]

const pressedTracker = [
	{
		index: 0,
		first: false,
		second: false
	},
	{
		index: 1,
		first: false,
		second: false
	},
	{
		index: 2,
		first: false,
		second: false
	},
	{
		index: 3,
		first: false,
		second: false
	},
	{
		index: 4,
		first: false,
		second: false
	},
]

let clear = false;

export default class Transition1 extends React.Component {
  static navigationOptions = {
    header: null,
  }

  state = {
  	count: 0,
  	dancerState: dancerList,
  	formationState: formationTwo,
  	transitionState: transitionPoint,
  	showTransitions: pressedTracker,
  }

  componentWillMount() {
    Expo.ScreenOrientation.allowAsync(Expo.ScreenOrientation.Orientation.LANDSCAPE);
    StatusBar.setHidden(true);
  }

  componentWillUnmount() {
    Expo.ScreenOrientation.allowAsync(Expo.ScreenOrientation.Orientation.PORTRAIT);
    //StatusBar.setHidden(false);
  }

  setClear = () => {
  	clear = false;
  }

  setDancerPress = (index) => {
  	let current = this.state.count;
  	current++;
  	this.setState({count: current})
  	let holder = this.state.showTransitions;
  	holder[index].first = true;
  	this.setState({showTransitions: holder})
  }

  setSecondPress = (index) => {
  	let current = this.state.count;
  	current++;
  	this.setState({count: current})
  	let holder = this.state.showTransitions;
  	holder[index].second = true;
  	this.setState({showTransitions: holder})
  }

  returnTopText = () => {
  	if(this.state.count % 2 == 0) {
  		return "Tap a dancer from Formation 1"
  	}
  	return "Tap an endpoint from Formation 2"
  }

  clearTransitions = () => {
  	const reset = [
	{
		index: 0,
		first: false,
		second: false
	},
	{
		index: 1,
		first: false,
		second: false
	},
	{
		index: 2,
		first: false,
		second: false
	},
	{
		index: 3,
		first: false,
		second: false
	},
	{
		index: 4,
		first: false,
		second: false
	}]
	this.setState({showTransitions: reset});
	clear = true;
  }

  renderTransitions() {
	var transitions = transitionPoint;
	var pressed = this.state.showTransitions;
	let status = [
		pressed[0].first && pressed[0].second,
		pressed[1].first && pressed[1].second,
		pressed[2].first && pressed[2].second,
		pressed[3].first && pressed[3].second,
		pressed[4].first && pressed[4].second
	]
/*
	let result = [];

	for (let i = 0; i < transitions.length; i++) {
		//if (status[i]) {
			result.push(
				<React.Fragment>
					<Svg.Line
					x1 = {transitions[i].x1}
					y1 = {(transitions[i].y1) }
					x2 = {transitions[i].x2}
					y2 = {(transitions[i].y2)}
					stroke = {Colors.lightGradient}
					strokeWidth = "5"/>
				</React.Fragment>
			)
		//}
	}

				opacity = {status[4] ? 1 : 0}

	return (result)*/

  	return (
	  	<React.Fragment>
	  		<Svg.Line
				x1 = {transitions[0].x1}
				y1 = {(transitions[0].y1) }
				x2 = {transitions[0].x2}
				y2 = {(transitions[0].y2)}
				stroke = {Colors.lightGradient}
				strokeWidth = "5"
				opacity = {status[0] ? 1 : 0}
			/>
			<Svg.Line
				x1 = {transitions[1].x1}
				y1 = {(transitions[1].y1) }
				x2 = {transitions[1].x2}
				y2 = {(transitions[1].y2)}
				stroke = {Colors.lightGradient}
				strokeWidth = "5"
				opacity = {status[1] ? 1 : 0}
			/>
			<Svg.Line
				x1 = {transitions[2].x1}
				y1 = {transitions[2].y1}
				x2 = {transitions[2].x2}
				y2 = {transitions[2].y2}
				stroke = {Colors.lightGradient}
				strokeWidth = "5"
				opacity = {status[2] ? 1 : 0}
			/>
			<Svg.Line
				x1 = {transitions[3].x1}
				y1 = {transitions[3].y1}
				x2 = {transitions[3].x2}
				y2 = {transitions[3].y2}
				stroke = {Colors.lightGradient}
				strokeWidth = "5"
				opacity = {status[3] ? 1 : 0}
			/>
			<Svg.Line
				x1 = {transitions[4].x1}
				y1 = {transitions[4].y1}
				x2 = {transitions[4].x2}
				y2 = {transitions[4].y2}
				stroke = {Colors.lightGradient}
				strokeWidth = "5"
				opacity = {status[4] ? 1 : 0}
			/>
		</React.Fragment>
  	)
  }

  renderEverything() {
  	var list = [];
  	let dancers = this.state.dancerState;
  	let second = this.state.formationState;
  	let displayDancers = [];
  	let displaySecond = [];

  	//var second = this.state.formationState;

  	for (let i = 0; i < dancers.length; i++) {
  		displayDancers.push(
  			<DancerTransition resetClear = {this.setClear.bind()} clear = {clear} setDancerPress = {this.setDancerPress.bind()} index = {i} name = {dancers[i].name} x = {dancers[i].xVal} y = {dancers[i].yVal}/>
  		)
  	}

  	for (let i = 0; i < second.length; i++) {
  		displaySecond.push(
  			<SecondFormation setSecondPress = {this.setSecondPress.bind()} index = {i} name = {second[i].name} x = {second[i].xVal} y = {second[i].yVal}/>
  		)
  	}

  	list.push(displayDancers, displaySecond);
  	return (
  		<View style = {{flex: 1}}>
  			{list}
  		</View>
	)
  }

  render() {
  	return (
		<SafeAreaView style = {styles.container}>
		        <ImageBackground style={styles.grid} source={require('../Images/grid.png')}>
		          <View style = {styles.topBar}>
		            <Text
		              style = {{color: Colors.lightGradient, fontSize: 18, fontWeight: 'bold', marginLeft: 12, marginTop: 3.5}}>
		              Formation 1
		            </Text>
		            <Text style = {{color: Colors.snow, fontSize: 24, marginLeft: 17, marginBottom: 7}}>
		              {this.returnTopText()}
		            </Text>
		            <Text style = {{color: 'purple', fontSize: 18, marginLeft: 11, fontWeight: 'bold', marginTop: 4, marginRight: 10}}>
		              Formation 2
		            </Text>
		          </View>
		          <View style = {{flex: 10}}>
		          	<Svg width = "600" height = "400" style = {{position: 'absolute', left: -344, top: 3}}>
		          	  {this.renderTransitions()}
		          	</Svg>
		            <View style = {styles.transitionSection}>
			        	{this.renderEverything()}
			        </View>
			      </View>
		          <View style = {styles.bottomBar}>
		          	<TouchableOpacity style = {styles.bottomButton}>
		              <Text
		                style = {{color: 'white', fontSize: 20}}>
		                BACK
		              </Text>
		            </TouchableOpacity>
		          	<TouchableOpacity style = {styles.bottomButtonRight} onPress = {() => this.clearTransitions()}>
		              <Text
		                style = {{color: 'white', fontSize: 20, width: 110, marginLeft: 50}}>
		                CLEAR
		              </Text>
		            </TouchableOpacity>
		            <TouchableOpacity style = {styles.bottomButtonRight}>
		              <Text
		                style = {{color: 'white', fontSize: 20}}>
		                SAVE
		              </Text>
		            </TouchableOpacity>
		          </View>
		        </ImageBackground>
	        </SafeAreaView>
	    );
    }
}


//
const styles = StyleSheet.create({
  container: {
    flex: 1,
  },
  transitionSection: {
  	alignItems: 'flex-start',
  	justifyContent: 'flex-start',
  	position: 'absolute',
  	left: -368
  },
  smallImageWrapper: {
    alignItems: 'center',
    justifyContent: 'center',
    marginRight: 20
  },
  grid: {
    flex: 1,
    alignSelf: 'stretch',
    width: '100%',
    //backgroundColor: 'blue',
    //height: undefined,
    alignItems: 'center',
    justifyContent: 'center',
    flexDirection: 'column'
  },
  topBar: {
    height: Platform.OS === 'ios' ? 44 : 56,
    width: '100%',
    backgroundColor: Colors.accent,
    paddingTop: 10,
    marginLeft: 50,
    marginRight: 50,
    flex: 1.2,
    flexDirection: 'row',
    justifyContent: 'space-between',
    alignItems: 'flex-start'
  },
  bottomBar: {
    flex: 1.5,
    width: '100%',
    flexDirection: 'row',
    justifyContent: 'flex-start',
    alignItems: 'flex-start',
    marginBottom: 17
  },
  bottomButton: {
    marginRight: 398,
    marginLeft: 10,
    backgroundColor: Colors.darkGradient,
    justifyContent: 'center',
    alignItems: 'center',
    width: 100,
    height: 50,
    borderRadius: 75
  },
  bottomButtonRight: {
    marginLeft: 10,
    backgroundColor: Colors.darkGradient,
    justifyContent: 'center',
    alignItems: 'center',
    width: 100,
    height: 50,
    borderRadius: 75
  },
  circle: {
    justifyContent: 'center',
    alignItems: 'center',
    backgroundColor: Colors.lightGradient,
    width: CIRCLE_RADIUS * 2,
    borderRadius: CIRCLE_RADIUS * 2,
    borderWidth: 3,
    height: CIRCLE_RADIUS * 2,
    borderRadius: CIRCLE_RADIUS
  },
});
