import React from 'react'
import { TouchableOpacity, View, StyleSheet, Text, TextInput} from 'react-native'
import { Feather }                 from '@expo/vector-icons'
import { CircleButton }            from '../Components'
import { Colors, Images, Metrics } from '../Themes'

/**
 * 2nd PreCreate Screen. Upload Song here.
 */
export default class UploadSong extends React.Component {
  static navigationOptions = {
    header: null,
  }

  render() {
    return (
      <View style={styles.container}>
        <Text style={styles.text}>UPLOAD A SONG</Text>
        <CircleButton style={{marginTop: Metrics.screenHeight*0.15}} source={Images.upload}/>
        <View style={styles.buttonContainer}>
          <CircleButton icon='arrow-left'
            onPress={() => this.props.navigation.goBack()}/>
          <CircleButton icon='arrow-right'
            onPress={() => this.props.navigation.navigate('Overview')}/>
        </View>
      </View>
    );
  }
}

const styles = StyleSheet.create({
  container: {
    flex: 1,
    justifyContent: 'center',
    alignItems: 'center',
    backgroundColor: Colors.background,
  },
  text: {
    fontSize: Metrics.text.button,
    margin: Metrics.baseMargin,
    color: Colors.snow,
    position: 'absolute',
    top: Metrics.screenHeight*0.4,
  },
  buttonContainer: {
    flex: 1,
    flexDirection: 'row',
    justifyContent: 'space-between',
    position: 'absolute',
    bottom: Metrics.screenHeight * 0.05,
    width: Metrics.screenWidth,
    paddingHorizontal: Metrics.doubleBaseMargin * 2,
  },
});
